#include <cstdio>

#include "settings.hh"
#include "buffer.hh"

using std::fprintf;

static unsigned msg_num_discards   = 0;
static unsigned msg_num_duplicates = 0;
static unsigned msg_cur_position   = 0;

void MessageDiscardFrame()
{
    ++msg_num_discards;
    fprintf(stderr, "\nDiscarded frame at %u\n", msg_cur_position);
}

void MessageCapturedFrame(unsigned count)
{
    if(count > 1)
    {
        msg_num_duplicates += count-1;
        fprintf(stderr, "\nDuplicate frame (%u) at %u\n", count, msg_cur_position);
    }
}

void MessageFrameCounter(unsigned num)
{
    msg_cur_position = num;
    
    fprintf(stderr, "\rframe(%8u) - discards(%4u) dups(%4u) buf(%10s), time(%.1f)",
        msg_cur_position,
        msg_num_discards,
        msg_num_duplicates,
        GetBufferStatus().c_str(),
        msg_cur_position / (FPS * 1.0)
        );
}

void MessageEnd()
{
    fprintf(stderr, "\nOwari\n");
}

